/* fft.h: Header for iterative implementation of a FFT
 * Copyright (C) 1999 Richard Boulton <richard@tartarus.org>
 */

#ifndef _LV_FFT_H
#define _LV_FFT_H

#define FFT_BUFFER_SIZE_LOG 9

#define FFT_BUFFER_SIZE (1 << FFT_BUFFER_SIZE_LOG)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* FFT library */
typedef struct _struct_fft_state fft_state;

fft_state *_lv_fft_init (void);
void _lv_fft_perform (const short int *input, float *output, fft_state *state);
void _lv_fft_close (fft_state *state);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _LV_FFT_H */
