#ifndef _LV_INPUT_H
#define _LV_INPUT_H

#include <libvisual/lv_audio.h>
#include <libvisual/lv_plugin.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _VisInput VisInput;

typedef int (*input_upload_callback_func_t)(VisInput *, VisAudio *, void *);

struct _VisInput {
	LVPlugin			*plugin;
	VisAudio			*audio;

	input_upload_callback_func_t	 callback;
	
	void				*private;
};

/* prototypes */
VisList *visual_input_get_list ();
char *visual_input_get_next_by_name (char *name);
char *visual_input_get_prev_by_name (char *name);
int visual_morph_valid_by_name (char *name);

VisInput *visual_input_new (char *inputname);

int visual_input_realize (VisInput *input);
int visual_input_destroy (VisInput *input);
int visual_input_free (VisInput *input);

int visual_input_set_callback (VisInput *input, input_upload_callback_func_t callback, void *private);

int visual_input_run (VisInput *input);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _LV_INPUT_H */
