#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include <config.h>

#include <lv_plugin.h>
#include <lv_libvisual.h>

int __lv_initialized = FALSE;
char *__lv_progname = NULL;

VisList *__lv_plugins = NULL;
VisList *__lv_plugins_actor = NULL;
VisList *__lv_plugins_input = NULL;
VisList *__lv_plugins_morph = NULL;

int __lv_plugpath_cnt = 0;
char **__lv_plugpaths = NULL;

const char *visual_get_version ()
{
	return VERSION;
}

int visual_init_path_add (char *pathadd)
{
	if (pathadd == NULL)
		return -1;

	__lv_plugpath_cnt++;
	__lv_plugpaths = realloc (__lv_plugpaths, sizeof (char *) * __lv_plugpath_cnt);
	__lv_plugpaths[__lv_plugpath_cnt - 1] = pathadd;

	return 0;
}

int visual_init (int *argc, char **argv[])
{
	if (__lv_initialized == TRUE)
		/* FIXME use lv_log */
		printf ("Over initialized\n");
	
	if (argc == NULL || argv == NULL) {
		if (argc != NULL || argv != NULL)
			printf ("OI, your argc,argv is fucked\n");
		/*  FIXME, print a warning here, one
		 *  is NULL and one isn't */
		__lv_progname = "no progname";
	} else
		__lv_progname = *argv[0];

	visual_init_path_add (PLUGPATH"/actor");
	visual_init_path_add (PLUGPATH"/input");
	visual_init_path_add (PLUGPATH"/morph");
	
	__lv_plugins = _lv_plugin_get_list (__lv_plugpaths, __lv_plugpath_cnt);
	__lv_plugins_actor = visual_plugin_registry_filter (__lv_plugins, VISUAL_PLUGIN_TYPE_ACTOR);
	__lv_plugins_input = visual_plugin_registry_filter (__lv_plugins, VISUAL_PLUGIN_TYPE_INPUT);
	__lv_plugins_morph = visual_plugin_registry_filter (__lv_plugins, VISUAL_PLUGIN_TYPE_MORPH);

	__lv_initialized = TRUE;
	return 0;
}

int visual_quit ()
{
	if (__lv_initialized == FALSE) {
		/* FIXME print a warning here */
		return -1;
	}

	visual_plugin_ref_list_destroy (__lv_plugins);
	visual_list_destroy (__lv_plugins_actor, NULL);
	visual_list_destroy (__lv_plugins_input, NULL);
	visual_list_destroy (__lv_plugins_morph, NULL);

	__lv_initialized = FALSE;
	return 0;
}

