#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>

#include <lv_log.h>

extern char *__lv_progname;

static const char *log_niveau_to_string (int niveau);

static const char *log_niveau_to_string (int niveau)
{
	switch (niveau)
	{
		case VISUAL_LOG_LEVEL_DEBUG:
			return "DEBUG";

		case VISUAL_LOG_LEVEL_INFO:
			return "INFO";

		case VISUAL_LOG_LEVEL_MESSAGE:
			return "MESSAGE";

		case VISUAL_LOG_LEVEL_WARNING:
			return "WARNING";

		case VISUAL_LOG_LEVEL_CRITICAL:
			return "CRITICAL";

		case VISUAL_LOG_LEVEL_ERROR:
			return "ERROR";

		default:
			return "INVALID LOG LEVEL";
	}

	return "ERROR WITHIN LOG SYSTEM";
}

int _lv_log (int niveau, const char *fmt, ...)
{
	char str[1024];
	va_list va;
	
	if (fmt == NULL) {
		fprintf (stderr, "lv_log: miss use of lv_log, format %p\n", fmt);
		return -1;
	}
	
	va_start (va, fmt);
	vsnprintf (str, 1023, fmt, va);
	va_end (va);
	
	fprintf (stderr, "(%s:%d): libvisual-%s **: %s\n",
			__lv_progname, getpid (), log_niveau_to_string (niveau),
			str);

	return 0;
}

