#ifndef _LV_LOG_H
#define _LV_LOG_H

#include <stdarg.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

enum {
	VISUAL_LOG_LEVEL_DEBUG,
	VISUAL_LOG_LEVEL_INFO,
	VISUAL_LOG_LEVEL_MESSAGE,
	VISUAL_LOG_LEVEL_WARNING,
	VISUAL_LOG_LEVEL_CRITICAL,
	VISUAL_LOG_LEVEL_ERROR
};

#ifdef __GNUC__
#define visual_log(niveau, message)			\
	_lv_log (niveau,				\
		"%s:%d, %s (): %s",			\
		__FILE__,				\
		__LINE__,				\
		__PRETTY_FUNCTION__,			\
		message)

#else /* !__GNUC__ */
#define visual_log(niveau, message)			\
	_lv_log (niveau,				\
		"%s:%d: %s",				\
		__FILE__,				\
		__LINE__,				\
		message)
#endif
	
int _lv_log (int niveau, const char *fmt, ...);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _LV_LOG_H */
