#ifndef _LV_MORPH_H
#define _LV_MORPH_H

#include <libvisual/lv_palette.h>
#include <libvisual/lv_plugin.h>
#include <libvisual/lv_list.h>
#include <libvisual/lv_video.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _VisMorph VisMorph;

struct _VisMorph {
	LVPlugin	*plugin;
	VisVideo	*dest;

	float		 rate;

	VisPalette	 morphpal;	
};

VisList *visual_morph_get_list ();
char *visual_morph_get_next_by_name (char *name);
char *visual_morph_get_prev_by_name (char *name);
int visual_morph_valid_by_name (char *name);

VisMorph *visual_morph_new (char *morphname);

int visual_morph_realize (VisMorph *morph);
int visual_morph_destroy (VisMorph *morph);
int visual_morph_free (VisMorph *morph);

int visual_morph_get_supported_depth (VisMorph *morph);

int visual_morph_set_video (VisMorph *morph, VisVideo *video);
int visual_morph_set_rate (VisMorph *morph, float rate);

VisPalette *visual_morph_get_palette (VisMorph *morph);

int visual_morph_run (VisMorph *morph, VisAudio *audio, VisVideo *src1, VisVideo *src2);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _LV_MORPH_H */
