#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <lv_palette.h>

VisPalette *visual_palette_new ()
{
	VisPalette *pal;

	pal = malloc (sizeof (VisPalette));
	memset (pal, 0, sizeof (VisPalette));

	return pal;
}

int visual_palette_free (VisPalette *pal)
{
	if (pal == NULL)
		return -1;

	free (pal);

	return 0;
}

int visual_palette_blend (VisPalette *dest, VisPalette *src1, VisPalette *src2, float rate)
{
	int i;

	if (dest == NULL || src1 == NULL || src2 == NULL)
		return -1;

	for (i = 0; i < 256; i++) {
		dest->r[i] = src1->r[i] + ((src2->r[i] - src1->r[i]) * rate);
		dest->g[i] = src1->g[i] + ((src2->g[i] - src1->g[i]) * rate);
		dest->b[i] = src1->b[i] + ((src2->b[i] - src1->b[i]) * rate);
	}

	return 0;
}

