#ifndef _LV_SONGINFO_H
#define _LV_SONGINFO_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <time.h>

#include <libvisual/lv_video.h>

enum {
	VISUAL_SONGINFO_TYPE_NULL,
	VISUAL_SONGINFO_TYPE_SIMPLE,
	VISUAL_SONGINFO_TYPE_ADVANCED
};

typedef struct _VisSongInfo VisSongInfo;

struct _VisSongInfo {
	int		interface;

	/* In seconds */
	int		length;
	int		elapsed;

	/* Simple interface */
	char		*songname;
	
	/* Advanced interface */
	char		*artist;
	char		*album;
	char		*song;

	/* Timing */
	time_t		 start;
	
	/* Cover art */
	VisVideo	*cover;
};

VisSongInfo *visual_songinfo_new (int interface);
int visual_songinfo_free (VisSongInfo *songinfo);
int visual_songinfo_free_strings (VisSongInfo *songinfo);
int visual_songinfo_set_interface (VisSongInfo *songinfo, int interface);
int visual_songinfo_set_length (VisSongInfo *songinfo, int length);
int visual_songinfo_set_elapsed (VisSongInfo *songinfo, int elapsed);
int visual_songinfo_set_simple_name (VisSongInfo *songinfo, char *name);
int visual_songinfo_set_artist (VisSongInfo *songinfo, char *artist);
int visual_songinfo_set_album (VisSongInfo *songinfo, char *album);
int visual_songinfo_set_song (VisSongInfo *songinfo, char *song);
int visual_songinfo_set_cover (VisSongInfo *songinfo, VisVideo *cover);
int visual_songinfo_mark (VisSongInfo *songinfo);
time_t visual_songinfo_age (VisSongInfo *songinfo);
int visual_songinfo_copy (VisSongInfo *dest, VisSongInfo *src);
int visual_songinfo_compare (VisSongInfo *s1, VisSongInfo *s2);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _LV_SONGINFO_H */
