#include <unistd.h>
#include <stdlib.h>

#include <libvisual.h>

int main ()
{
	VisPluginRef *ref;
	VisActorPlugin *plugin;
	VisPluginInfo *info;

	VisList *list;
	VisListEntry *entry = NULL;
	
	list = _lv_plugin_actor_get_list ("/usr/lib/libvisual/actor");

	while ((ref = visual_list_next (list, &entry)) != NULL) {
		printf ("Plugin ref %s, %s, %d, ptr: %p\n",
				ref->file, ref->name, ref->usecount,
				ref);

		plugin = _lv_plugin_actor_load (ref);
	
		_lv_plugin_actor_unload (plugin);

		info = ref->info;

		printf ("Plugin info: %s, %s, %s, %s, %s\n\n",
				info->name, info->author, info->version,
				info->about, info->help);

	}
}
