#include <stdio.h>
#include <stdlib.h>

#include <libvisual.h>

int sample_callback (VisInput *input, VisAudio *audio, void *private)
{
	int i;
	
	printf ("Sample callback has been called, private test string %s\n", (char *) private);

	for (i = 0; i < 512; i++) {
		audio->plugpcm[0][i] = rand () % 0xffff;
		audio->plugpcm[1][i] = rand () % 0xffff;
	}

	return 0;
}

int main ()
{
	VisInput *input;
	VisList *inlist;

	int i;

	inlist = visual_input_get_list (NULL);
	input = visual_input_new (inlist, NULL);
	visual_input_realize (input);
	visual_input_set_callback (input, sample_callback, "test123");

	for (i = 0; i < 100; i++) {
		visual_input_run (input);

		printf ("pcm[2]: %d %d\n", input->audio->pcm[2][128],
				input->audio->pcm[2][396]);
	}

	visual_input_destroy (input);
	visual_input_list_destroy (inlist);
}

